/****************************************************

Greedy algorithm for pmedian
Ecrit par Sourour Elloumi en fevrier 2005

Compilation :   g++ -Wno-deprecated -o greedymedian greedymedian.cc

Usage : ./greedymedian fichdonnees fichsol

Exemple :   ./greedymedian pmed.dat pmed.sol

*********************************************** */
#include <iostream.h>

#define Infinity  1000000000000000000.0

const int MAX_N = 6000;
typedef float MatDist[MAX_N][MAX_N];

/******************************************************/
/*      Lecture du probleme (fichier standard         */
/******************************************************/

int lecture (char * nomfichier,int &N, int &M,int &P, MatDist d)
{
FILE *f;
int i,j;
float lu;

 f=fopen(nomfichier,"r");
 if( f==NULL) {
	printf("Erreur de lecture du fichier :%s\n",nomfichier);
	return(-1);
	}
    else
	{

	 fscanf(f,"%d %d %d\n",&N, &M, &P); /**/
	 cout <<"N= "<<N << "M= " <<M << "P= "<< P;
	 	  
	 /*lecture des distances : matrice d*/
         for  (i=0;i<N;i++)
           { for (j=0;j<M;j++){ fscanf(f, "%f ", &lu); 
                                if (lu==-1) d[i][j]=Infinity; else  d[i][j]=lu;
	                        /* printf ("\ni=%d j=%d d=%f",i,j,(d)[i][j]);*/
	                        }
              fscanf(f, "\n");
            }
	fclose(f);

	return(0);
	}
 
 }


//*************************************************

 void  ecriture_sol (char * outfile, int M, float Val_sol, int sol[])
{
 int i,j;
 FILE *fp;
 fp = fopen(outfile,"w");
 { for (j=0;j<M;j++) if (sol[j]==1) fprintf(fp, "%d\n", j+1);
   fprintf(fp, "%f\n", Val_sol);
 }
 fclose(fp);
}

//*************************************************

 float calcul_sol (int N, int M,int P, MatDist d, int o[])
 {
 int i,j;
 float cur_rad_i;
 float median;

 median = 0;
 for (i=0; i<N;i++)
   {  cur_rad_i=Infinity+10.0;
      for (j=0;j<M;j++) if (o[j]==1)
         if (d[i][j] < cur_rad_i) cur_rad_i=d[i][j];
      median += cur_rad_i;
   }  
 return (median);
 }

//*************************************************

 float greedy_median (int N, int M,int P, MatDist d, int opened[] )
 {
 int i,j, best_j;
 float cur_rad[N];
 float median_j, newmedian_j, min_median, rad_i;
 int nbopen;

 for (j=0;j<M;j++) opened[j] = 0;
 
/* solve the 1-median problem */
 min_median= 0;
 for (i=0; i<N;i++)  min_median +=d[i][0];

 for (j=1;j<M;j++)
 { 
   //median_j = sum on i(d[i,j])
     // cout << "min_median=" <<min_median <<endl;
   median_j = 0;
   for (i=0; i<N;i++)  median_j +=d[i][j];
   if (median_j < min_median){ best_j=j; min_median = median_j;} 
 }

 for (j=0;j<M;j++) opened[j] =0;
 opened[best_j]=1; 
 nbopen = 1;
 for (i=0; i<N;i++) cur_rad[i]=d[i][best_j];
  
 /*add P-1 other facilities */
 while (nbopen <P)
   {
     best_j=0;
    for (j=0;j<M;j++) if (opened[j] == 0)
      {
        // si j ouvert, nouveaux rad_i et newmedian_j 
        newmedian_j = 0;
        for (i=0; i<N;i++) 
        {
          if ( d[i][j] < cur_rad[i]) rad_i=d[i][j];
                  else rad_i=cur_rad[i];           
          newmedian_j += rad_i;
        }
         //printf ("newmedian_%d=%d\n", j, newmedian_j);
        if (newmedian_j <= min_median){ best_j=j; min_median = newmedian_j;}
      }

    // cout << "min_median=" <<min_median <<endl;
    opened[best_j]=1; 
     nbopen += 1;
     for (i=0; i<N;i++)
         if (d[i][best_j] < cur_rad[i]) cur_rad[i]=d[i][best_j];     
   } //end while
 
 if (min_median != calcul_sol (N,M,P,d, opened)) cout << "Anomalie"<<endl;
 return (min_median);
 }




/******************************************************/
/*                 Procedure principale               */
/******************************************************/

int main( int argc, char *argv[] )
 {
 int i,j, k; 
 int N; 	/* Nb de clients */
 int M;         /* Nb de facilites */
 int P; 	/* Nb de processeurs */
 int test;	/* test de bon deroulement de procedures */
 MatDist matd;	/* matrice des distances */
 float Bsup;
 int ouv_greedy[MAX_N];
  
  clock_t finish, reference;
   double  duration;

//   cout <<"debut"  << endl;
 reference = clock();
 if(argc !=3)
 	{printf("mauvais passage de parametres !\n");
	 printf("usage : prog fichdonnees fichsol \n");
	 return(-1);
	}
 else
 	{
	    //cout <<"nomfich = " <<argv[1]  << endl;
	    test=lecture (argv[1],N,M,P,matd); //printf("Fin lecture 1\n");


//for (j=0;j<M;j++) ouv_greedy[j] = 0;
// ouv_greedy[0]=1; ouv_greedy[19]=1; ouv_greedy[23]=1; ouv_greedy[34]=1; ouv_greedy[41]=1;
//cout <<"*****cout = " << calcul_sol (N,M,P,matd, ouv_greedy) << endl;
//printf( "*****cout%f\n", calcul_sol (N,M,P,matd, ouv_greedy));

	if(test)
		return(-1);
	else
	  {              
	    //printf("fin lecture\n");
             finish= clock();
	     duration = (double)(finish - reference) / CLOCKS_PER_SEC;
             reference=finish;
             printf( "@@@@@@@@@@@Temps lecture-> %2.1f seconds\n", duration );

	     //Appel greedy
            Bsup=greedy_median (N,M,P,matd, ouv_greedy);
            //printf("Borne Sup greedy= %d\n", Bsup);
	    //for (j=0;j<M;j++) 
            //   if (ouv_greedy[j] == 1)  cout<<j <<"ouvert" << endl;
            ecriture_sol (argv[2], M, Bsup, ouv_greedy);

             finish= clock();
	     duration = (double)(finish - reference) / CLOCKS_PER_SEC;
             reference=finish;
             printf( "@@@@@@@@@@@Temps greedy-> %2.1f seconds\n", duration );


           }
		
	}
 }
 
 
 















